outlets = 3;
var W = 500.0;
var H = 500.0;
var FEETPIX = 1.0;


var NUMSPKRS = 8;
spkrs = new Array(NUMSPKRS);
srcloc = new Array(2);


init();

function init() {
	var i;
	for (i = 0; i < NUMSPKRS; i++) {
		spkrs[i] = new Array(2);
	}
}

function setup() {
	// 500 x 500 pixel*FEETPIX space, speakers in the middle
	spkrs[0][0] = 250.0 - (3.0/FEETPIX);
	spkrs[0][1] = 250.0 - (10.0/FEETPIX);
	
	spkrs[1][0] = 250.0 + (3.0/FEETPIX);
	spkrs[1][1] = 250.0 - (10.0/FEETPIX);
	
	spkrs[2][0] = 250.0 - (6.0/FEETPIX);
	spkrs[2][1] = 250.0 - (5.0/FEETPIX);
	
	spkrs[3][0] = 250.0 + (6.0/FEETPIX);
	spkrs[3][1] = 250.0 - (5.0/FEETPIX);
	
	spkrs[4][0] = 250.0 - (6.0/FEETPIX);
	spkrs[4][1] = 250.0 + (5.0/FEETPIX);
	
	spkrs[5][0] = 250.0 + (6.0/FEETPIX);
	spkrs[5][1] = 250.0 + (5.0/FEETPIX);
	
	spkrs[6][0] = 250.0 - (3.0/FEETPIX);
	spkrs[6][1] = 250.0 + (10.0/FEETPIX);
	
	spkrs[7][0] = 250.0 + (3.0/FEETPIX);
	spkrs[7][1] = 250.0 + (10.0/FEETPIX);
	
	
	srcloc[0] = 400;
	srcloc[1] = 150;

	// send out the new values
	gorect();
	bang();
}

function setvals(sval, x, y) {
	if (sval < NUMSPKRS) {
		spkrs[sval][0] = x;
		spkrs[sval][1] = y;
	} else if (sval == 8) {
		srcloc[0] = x;
		srcloc[1] = y;
	}
}

function setsrc(x, y) {
	srcloc[0] = x;
	srcloc[1] = y;
	
	// send out the new values
	gorect();
	bang();
}

function setfeetpix(val) {
	FEETPIX = val;
	
	setup();
}

function bang()
{
	dels = new Array(NUMSPKRS);
	amps = new Array(NUMSPKRS);
	var i;
	for (i = 0; i < NUMSPKRS; i++) {
		dels[i] = Math.pow((spkrs[i][0]+5)-(srcloc[0]+5), 2) + Math.pow((spkrs[i][1]+5)-(srcloc[1]+5), 2);
		dels[i] = Math.pow(dels[i], 0.5);
		// yes, I know that amp = 1/distance^2, but the power vs. volume + 2-d (and lack of ground
		//	reflections, etc.) made it sound not-so-good.  Hey, I'm a flaky musician!  I use a
		//	simple linear amp fall-off, and the 20.0 gain factor is totally arbitrary.  It sounded good.
		amps[i] = 1./(dels[i]*FEETPIX) * 20.0;
		dels[i] = (dels[i]*FEETPIX)/1100.0 * 44100.0; // generic speed of sound, 1100 ft/sec
	}
	outlet(1, dels);
	outlet(2, amps);
}


function gorect()
{
	var i;

	outlet(0, "clear");
	// src
	outlet(0, "paintoval " + srcloc[0] + " " + srcloc[1] + " " +
		(srcloc[0]+10) + " " + (srcloc[1]+10) + " 200 0 0");

	// spkrs
	for (i = 0; i < NUMSPKRS; i++) {
		outlet(0, "paintrect " + spkrs[i][0] + " " + spkrs[i][1] +
			" " + (spkrs[i][0]+10) + " " + (spkrs[i][1]+10) +
			" 0 0 200");
		outlet(0, "linesegment " + (srcloc[0]+5) + " " + (srcloc[1]+5) +
			" " + (spkrs[i][0]+5) + " " + (spkrs[i][1]+5) + " 0 200 0");
	}
}
