

SynthDef("simpledelay", {
	var delout, insig;

	insig = SoundIn.ar(0);
	delout = DelayN.ar(insig, 1.0, 0.5, 1);
	Out.ar(0, delout);
}).play;

SynthDef("simplerecircdelay", {
	var delout = 0, insig;

	insig = SoundIn.ar(0);
	delout = DelayN.ar(insig+(0.5*delout), 1.0, 0.5, 1);
	Out.ar(0, delout);
}).play;


SynthDef("mousedelay", {
	var delout, insig;

	insig = SoundIn.ar(0);
	delout = DelayN.ar(insig, 1.0,
		MouseX.kr(0.01, 0.9), 1);
	Out.ar([0,1], delout*0.1);
}).play;


GUI.cursorPosition.x.postln;

Routine({
	loop ( {
		"hey".postln;
		1.yield;
	});
}).play;


Routine({
	loop ( {
		AppClock.sched(0, { GUI.cursorPosition.x.postln });
		0.5.yield;
	});
}).play;


SynthDef("mousedelay2", {
	arg deltime = 0.5;
	var delout, insig;

	insig = SoundIn.ar(0);
	delout = DelayN.ar(insig, 1.0, deltime, 1);
	Out.ar([0,1], delout*0.1);
}).play;

a = Synth("mousedelay2");
a.set(\deltime, 0.1);
a.set(\deltime, 0.9);
a.free;


(
var xval;

Routine({
	loop ( {
		AppClock.sched(0, { xval = GUI.cursorPosition.x });
		xval.postln;
		0.01.yield;
	});
}).play;
)


(
var xval, sss;
sss = Synth("mousedelay2");

Routine({
	loop ( {
		AppClock.sched(0, { xval = GUI.cursorPosition.x });
		0.01.yield;
		xval.postln;
		sss.set(\deltime, xval/1400.0);
	});
}).play;
)



SynthDef("mousedelay3L", {
	arg deltime = 0.5;
	var delout, insig;

	insig = SoundIn.ar(0);
	delout = DelayN.ar(insig, 1.0, deltime, 1);
	Out.ar(0, delout*0.1);
}).load;

SynthDef("mousedelay3R", {
	arg deltime = 0.5;
	var delout, insig;

	insig = SoundIn.ar(0);
	delout = DelayN.ar(insig, 1.0, deltime, 1);
	Out.ar(1, delout*0.1);
}).load;


(
var xval, ssL, ssR;
var feetR, feetL;
var dtimeR, dtimeL;

ssL = Synth("mousedelay3L");
ssR = Synth("mousedelay3R");

Routine({
	loop ( {
		AppClock.sched(0, { xval = GUI.cursorPosition.x });
		0.01.yield;
		feetR = (xval/1400 * 50) - 30;
		feetL = (xval/1400 * 50) - 20;
		// assume sound speed = 1000 ft/sec
		dtimeR = (feetR/1000).abs;
		dtimeL = (feetL/1000).abs;
		if (dtimeR == 0, { dtimeR = 0.001} );
		if (dtimeL == 0, { dtimeL = 0.001} );
		//dtimeR.postln;
		ssR.set(\deltime, dtimeR);
		ssL.set(\deltime, dtimeL);
	});
}).play;
)
